#ifndef __GSLIDER__
#define __GSLIDER__

#include <qwidget.h>
#include <qpixmap.h>
#include <qtimer.h>

class WASkin;

class GSlider : public QWidget
{
Q_OBJECT
friend class WASkin;
public:
                                GSlider(QWidget * parent = 0);

  void                          setValue(int);
  void                          setMax(int);
  int                           value(void);

protected:
  virtual void                  paintEvent(QPaintEvent *);
  virtual void                  mouseMoveEvent(QMouseEvent *);
  virtual void                  mousePressEvent(QMouseEvent *);
  virtual void                  mouseReleaseEvent(QMouseEvent *);
  virtual void                  wheelEvent(QWheelEvent *);

signals:
  void                          sliderPressed(void);
  void                          sliderMoved(int);
  void                          sliderReleased(void);

private:
  QPixmap                     * pmStage; // Dynamic array of pixmaps
  unsigned                      stageCount;
  unsigned                      currentStage;
  int                           offset, hoffset;
  int                           maximum;
  bool                          pressed;
  QPixmap                       pmButtonDown, pmButtonUp;
};

#endif
