#ifndef __WASKIN__
#define __WASKIN__

#include <qobject.h>
#include <qimage.h>
#include <qpixmap.h>
#include "zipextract.h"


class ControlPanel;
class GButton;
class GTextView;
class GSlider;

class WASkin : public QObject
{
Q_OBJECT
public:
                                WASkin(ControlPanel *);
                                WASkin(QString, QString, ControlPanel *);

  void                          setMainWidget(QWidget &);
  void                          setControlButtons(GButton &, GButton &, GButton &, GButton &, GButton &, GButton &);
  void                          setOptionButtons(GButton &, GButton &, GButton &, GButton &);
  void                          setTextView(GTextView &, GTextView &, GTextView &);
  void                          setSliders(GSlider &, GSlider &, GSlider &);
  void                          setTitleButtons(GButton &, GButton &, GButton &);

  QPixmap                     & getState(int);
  QPixmap                     & getNumber(int);

  inline QSize                  getSize(void) const                             { return imageMain.size(); }
  inline QString                getName(void) const                             { return name; }

public slots:
  void                          apply(void);
  void                          unload(void);

private:
  static bool                   isTransparent(QRgb p);

private:
  QString                       name;
  ZipExtract                    file;
  ControlPanel                * panel;
  QPixmap                       imageMain;
  QPixmap                       imageButtons;
  QPixmap                       imageOption;
  QPixmap                       imageText;
  QPixmap                       imageVolume;
  QPixmap                       imageBalance;
  QPixmap                       imagePlayPaus;
  QPixmap                       imageNumbers;
  QPixmap                       imagePosition;
  QPixmap                       imageTitlebar;
  unsigned                      numbers;
};

#endif
